Releases
--------

Steps for creating a new release of YAML block module


--------------------------------------------------------------------------------

1. Convert to short array syntax
2. Inspect code (PHPStorm / Coder review)
3. Run SimpleTests and UnitTests
4. Generate and edit release notes
5. Tag a release
6. Update project page
7, Create new release

--------------------------------------------------------------------------------

# Convert to short array syntax

    wget https://raw.githubusercontent.com/thomasbachem/php-short-array-syntax-converter/master/convert.php
    find . -name "*.install" -exec php "convert.php" -w "{}" \;
    find . -name "*.module" -exec php "convert.php" -w "{}" \;
    find . -name "*.php" -exec php "convert.php" -w "{}" \;
    find . -name "*.inc" -exec php "convert.php" -w "{}" \;
    rm convert.php
        
--------------------------------------------------------------------------------

# Inspect code (PHPStorm / Coder)

## References

- [Drupal Development using PhpStorm](https://confluence.jetbrains.com/display/PhpStorm/Drupal+Development+using+PhpStorm#DrupalDevelopmentusingPhpStorm-CoderandPHPCodeSnifferIntegration)
- [Installing Coder Sniffer](https://www.drupal.org/node/1419988)

## Online

- http://git.drupal.org/project/yamlblock.git 8.x-1.x
- [pareview.sh: Repeat review](http://pareview.sh/node/561406/repeat)

## [Commandline](https://www.drupal.org/node/1587138)

    # Check Drupal coding standards
    phpcs --standard=Drupal --extensions=php,module,inc,install,test,profile,theme,js,css,info,txt,md modules/sandbox/yamlblock

    # Check Drupal best practices
    phpcs --standard=DrupalPractice --extensions=php,module,inc,install,test,profile,theme,js,css,info,txt,md modules/sandbox/yamlblock


--------------------------------------------------------------------------------
    
# Run SimpleTest and PHPUnit

## SimpleTest

GUI (admin/config/development/testing)

Command-line (from site root)

    # Run all test included the yamlblock.module 
    php core/scripts/run-tests.sh --url http://localhost/d8_dev --module yamlblock   

--------------------------------------------------------------------------------

# Generate and edit release notes

Git Release Notes for Drush (https://www.drupal.org/project/grn)

    drush release-notes 8.x-1.0-alpha1 8.x-1.x
    
--------------------------------------------------------------------------------
    
# Tag a release

    git tag 8.x-1.0-alpha1
    git push --tags
    git push origin tag 8.x-1.0-alpha1

--------------------------------------------------------------------------------

# Update project page

Converting README.md to HTML for Drupal.org

- [Convert Markdown to HTML](http://daringfireball.net/projects/markdown/dingus)
- [Tidy HTML](https://infohound.net/tidy/)
    - No indent
    - No wrap   
- Manually cleanup
    - Remove `<html>` tags.
    - Remove 'Contents of this file'.
    - Update example code and wrap in `<pre>` tag.
- [Update project page](https://www.drupal.org/node/2640714/edit)
    - Preview 
    - Save

#  Create new release

- [Create Release](https://www.drupal.org/node/add/project-release/2640714)
- [Administer releases](https://www.drupal.org/node/2640714/edit/releases)
